# coding: utf-8

"""
    Project Service API

    Project Service exposes a REST API, providing access to operations with projects Example: 1. `$orderby` - Sorting criteria in the format: property (asc | desc). Default sort order is ascending.     ```/project-service/api/projects?$orderby=name%20desc``` 2. `$top` -  limits the requested number of resources.     ```/project-service/api/projects?$top=10``` 3. `$skip` -  client can skip a given number of resources.      ```/project-service/api/projects?$skip=2``` 4. `$top` & `$skip` - used in conjunction helps in pagination of resources        ```/project-service/api/projects?$top=10&$skip=2``` 5. `$filter` -  returns a subset of resources that satisfy the given predicate expression.     ```/project-service/api/projects?$filter=startswith(name, 'Test')```  # noqa: E501

    OpenAPI spec version: 2020-08-10
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AuthContextGroups(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'display_name': 'str',
        'group_type': 'str',
        'domain': 'str',
        'users_count': 'int'
    }

    attribute_map = {
        'id': 'id',
        'display_name': 'displayName',
        'group_type': 'groupType',
        'domain': 'domain',
        'users_count': 'usersCount'
    }

    def __init__(self, id=None, display_name=None, group_type=None, domain=None, users_count=None):  # noqa: E501
        """AuthContextGroups - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._display_name = None
        self._group_type = None
        self._domain = None
        self._users_count = None
        self.discriminator = None
        if id is not None:
            self.id = id
        self.display_name = display_name
        if group_type is not None:
            self.group_type = group_type
        if domain is not None:
            self.domain = domain
        if users_count is not None:
            self.users_count = users_count

    @property
    def id(self):
        """Gets the id of this AuthContextGroups.  # noqa: E501

        Group's Identity Provider ID  # noqa: E501

        :return: The id of this AuthContextGroups.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AuthContextGroups.

        Group's Identity Provider ID  # noqa: E501

        :param id: The id of this AuthContextGroups.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def display_name(self):
        """Gets the display_name of this AuthContextGroups.  # noqa: E501

        The account identifier string of the group.  # noqa: E501

        :return: The display_name of this AuthContextGroups.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this AuthContextGroups.

        The account identifier string of the group.  # noqa: E501

        :param display_name: The display_name of this AuthContextGroups.  # noqa: E501
        :type: str
        """
        if display_name is None:
            raise ValueError("Invalid value for `display_name`, must not be `None`")  # noqa: E501

        self._display_name = display_name

    @property
    def group_type(self):
        """Gets the group_type of this AuthContextGroups.  # noqa: E501

        The type of the group  # noqa: E501

        :return: The group_type of this AuthContextGroups.  # noqa: E501
        :rtype: str
        """
        return self._group_type

    @group_type.setter
    def group_type(self, group_type):
        """Sets the group_type of this AuthContextGroups.

        The type of the group  # noqa: E501

        :param group_type: The group_type of this AuthContextGroups.  # noqa: E501
        :type: str
        """

        self._group_type = group_type

    @property
    def domain(self):
        """Gets the domain of this AuthContextGroups.  # noqa: E501

        The domain of the group.  # noqa: E501

        :return: The domain of this AuthContextGroups.  # noqa: E501
        :rtype: str
        """
        return self._domain

    @domain.setter
    def domain(self, domain):
        """Sets the domain of this AuthContextGroups.

        The domain of the group.  # noqa: E501

        :param domain: The domain of this AuthContextGroups.  # noqa: E501
        :type: str
        """

        self._domain = domain

    @property
    def users_count(self):
        """Gets the users_count of this AuthContextGroups.  # noqa: E501

        The number of users added in the group.  # noqa: E501

        :return: The users_count of this AuthContextGroups.  # noqa: E501
        :rtype: int
        """
        return self._users_count

    @users_count.setter
    def users_count(self, users_count):
        """Sets the users_count of this AuthContextGroups.

        The number of users added in the group.  # noqa: E501

        :param users_count: The users_count of this AuthContextGroups.  # noqa: E501
        :type: int
        """

        self._users_count = users_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AuthContextGroups, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AuthContextGroups):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
